require File.expand_path('../connection', __FILE__)
require File.expand_path('../configuration', __FILE__)
require File.expand_path('../servicescsrf', __FILE__)
require File.expand_path('../request', __FILE__)

module TPEX
  # @private
  class API
    # @private
    attr_accessor *Configuration::VALID_OPTIONS_KEYS

    # Creates a new API
    def initialize(options={})
      options = TPEX.options.merge(options)
      Configuration::VALID_OPTIONS_KEYS.each do |key|
        send("#{key}=", options[key])
      end
    end

    include Connection
    include Request
    include ServicesCSRF
  end
end