require 'json'

module TPEX
	class Client
		module Auth
			def login()
				data = JSON.generate({"username" => username, "password" => password})
        # need raw response for set-cookie info
				response_raw = post('user/login', data, true)
        # puts "RAW RESPONSE: *********   #{response_raw.inspect}"

        response = Response.create( response_raw.body )
        # puts "OTHER RESPONSE: ******** #{response}"
        # save roles
        @roles = response['user']['roles']
        # puts "USER'S ROLES: #{@roles}"
        # puts "KEYS: ***** #{response.keys}"
        @cookie = "#{response["session_name"]}=#{response["sessid"]}"

        # production server cookies
        bnes = ""
        bni = ""
        junkout = response_raw["set-cookie"].split(";")
        junkout.each do |line|
          if line =~ /BNES_SESS/
            bnes = line.match(/(BNES_SESS.*)/)[0]
          end
        end
        junkout.each do |line|
          if line =~ /BNI/
            bni = line.match(/(BNI.*)/)[0]
          end
        end
        if bnes != ""
          @cookie = @cookie + ';' + bnes
        end
        if bni != ""
          @cookie = @cookie + ";" + bni
        end
        puts "COOKIES: #{@cookie}"
				response
			end

      def roles()
        return @roles
      end

			def logout()
				response = post('user/logout')
				@cookie = nil
				response
			end
		end
	end
end
