require "json"

module TPEX
  class Client
    module Files

      FIELDS = {
        file: {machine_name: "file", required: true},
        filename: {machine_name: "filename", required: true},
        filesize: {machine_name: "filesize", required: true}
      }

      File =  Struct.new(*FIELDS.keys)

      def post_file(file)
        data = jsonify_file(file)
        response = post("file", data)
      end

      def build_file(options={})
        required_fields = []
        arguments = []

        TPEX::Client::Files::FIELDS.each do |key, value|
          required_fields << key if value[:required]
          arguments << options[key]
        end

        required_fields.each do |key|
          return nil if options[key].nil?
        end

        return File.new(*arguments);
      end

      def jsonify_file(file)
        jsonobject = {}
        fields = TPEX::Client::Files::FIELDS

        file.each_pair do |name, value|
          if !value.nil?
            jsonobject[fields[name][:machine_name]] = value
          end
        end

        JSON.generate({"file" => jsonobject})
      end
    end
  end
end
