require "json"

module TPEX
	class Client
		module Products

			FIELDS = {
				manufacturer: {machine_name: "manufacturer"},
				certified: {machine_name: "field_certified", required: true},
				tags: {machine_name: "field_tags", required: true, label:"tid"},
				model_no: {machine_name: "field_model_num", required: true, enclosed: true},
				brand: {machine_name: "field_product_brand", required: true, enclosed: true},
				product_line: {machine_name: "field_product_line_family_name", enclosed: true},
				femp: {machine_name: "field_femp", required: true},
				upc: {machine_name: "field_universal_product_code_upc", enclosed: true},
				energy_star_no: {machine_name: "field_energy_star_specification_", enclosed: true},
				uuid: {machine_name: "uuid"}
			}

			Product =  Struct.new(*FIELDS.keys)

			# def get_product_by_uuid()

			# end

			def post_product(product)
				data = jsonify_product(product)
				response = post("content", data)
			end

			def build_product(options={})
				required_fields = []
				arguments = []

				TPEX::Client::Products::FIELDS.each do |key, value|
					required_fields << key if value[:required]
					arguments << options[key]
				end

				required_fields.each do |key|
					if options[key].nil?
						puts "***ERROR: required field #{key} is blank***"
					end
					return nil if options[key].nil?
				end
       
				return Product.new(*arguments);
			end

			def jsonify_product(product)
			    if !product[:uuid].nil?
					jsonobject = {"title" => "Json Object", "uuid" => product[:uuid]}
				else
					jsonobject = {"title" => "Json Object"}
				end
				fields = TPEX::Client::Products::FIELDS

				product.each_pair do |name, value|
					if name != :uuid
						if !value.nil?
							label = fields[name][:label] || "value"
							contents = {label => value}
							contents = [{label => value}] if fields[name][:enclosed]
							jsonobject[fields[name][:machine_name]] = {"und" => contents}
						end
					end
				end
				JSON.generate({"product" => jsonobject})
			end
		end
	end
end
