require 'faraday_middleware'
Dir[File.expand_path('../../faraday/*.rb', __FILE__)].each{|f| require f}

module TPEX
  # @private
  module Connection

    # private

    def connection(raw=false)

      options = {
        :headers => {
          'Accept' => "application/#{format}; charset=utf-8",
          'User-Agent' => user_agent,
          'Cookie' => cookie,
          'X-CSRF-Token' => access_token
        }.reject{ |k,v| v.nil? },
        :ssl => {:verify => false},
        :url => endpoint,
      }

      Faraday::Connection.new(options) do |c|
        c.use FaradayMiddleware::Mashify unless raw
        c.response :json, :content_type => /\bjson$/
        c.response :logger if @logging
        c.use FaradayMiddleware::RaiseHttpException
        c.adapter Faraday.default_adapter

      end
    end
  end
end
